// B4R Library rTM1638
#include "B4RDefines.h"
#include "TM16XXFonts.h"
namespace B4R {
	
			void B4RTM1638::Initialize(Byte dataPin, Byte clockPin, Byte strobePin, bool activateDisplay, Byte intensity){
				module = new (beTM1638) TM1638(dataPin, clockPin, strobePin, activateDisplay, intensity);
			}

			void B4RTM1638::SetDisplayToHexNumber(ULong number, Byte dots, bool leadingZeros){
				module->setDisplayToHexNumber(number,dots,leadingZeros, NUMBER_FONT);
			}

    	void B4RTM1638::SetDisplayToDecNumber(ULong number, Byte dots, bool leadingZeros){
				module->setDisplayToDecNumber(number, dots, leadingZeros, NUMBER_FONT);
    	}

    	void B4RTM1638::SetDisplayToSignedDecNumber(Long number, Byte dots, bool leadingZeros){
				module->setDisplayToSignedDecNumber(number, dots, leadingZeros, NUMBER_FONT);
    	}

    	void B4RTM1638::SetDisplayToBinNumber(Byte number, Byte dots){
				module->setDisplayToBinNumber(number, dots, NUMBER_FONT);
    	}

    	void B4RTM1638::SetLED(Byte color, Byte pos){
				module->setLED(color, pos);
    	}

    	void B4RTM1638::SetLEDs(UInt led){
				module->setLEDs(led);
    	}

	   	Byte B4RTM1638::GetButtons(){
				return module->getButtons();
	   	}

			void B4RTM1638::AddListener(SubVoidByte Event) {
				this->Event = Event;
				FunctionUnion fu;
				fu.PollerFunction = looper;
				pollers.add(fu, this);
			}
			 
			void B4RTM1638::looper(void* b) {
				B4RTM1638* tm = (B4RTM1638*)b;
				Byte newValue = tm->module->getButtons();
				if (newValue != tm->CurrentValue) {
					sender->wrapPointer(tm);
					tm->CurrentValue = newValue;
					tm->Event(newValue);
				}
			}

			//Next functions taken from TM16XX.h

	   	void B4RTM1638::ClearDisplay(){
				return module->clearDisplay();
	   	}

			void B4RTM1638::SetDisplayToError(){
				module->setDisplayToError();
			}

			void B4RTM1638::SetDisplayToString(B4RString* string){
				//String, no dots, start at position 0, use default font
				module->setDisplayToString(string->data, 0, 0, FONT_DEFAULT);
			}

			void B4RTM1638::SetDisplayDigit(Byte digit, Byte pos, bool dot){
				module->setDisplayDigit(digit, pos, dot, NUMBER_FONT);
			}

			void B4RTM1638::ClearDisplayDigit(Byte pos, bool dot){
				module->clearDisplayDigit(pos, dot);				
			}

    	void B4RTM1638::SetupDisplay(bool active, Byte intensity){
    		module->setupDisplay(active, intensity);
     	};

}

